#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.8.0
 Author:         Mirxo
 Schreibt auf:   http://www.computerbase.de/forum/    
 im Thread:      http://www.computerbase.de/forum/showthread.php?t=1058948            

 ScriptName:     AntiWerBung
 ScriptFunction: Erlaubt oder Verbietet Avira Werbung
 ScriptVersion:  1.9b-beta
 ScriptZustand:  Tests
 ScriptDatum:    24.05.2012

 ScriptInfo:     Statt angemessener 5 Euro jhrlich fr 1x Werbung pro Woche 
                 versucht Avira bei jedem AntiVir Nutzer ber 100 Euro pro Jahr
                 durch Missbrauch der Desktop-Flche abzugreifen:
                 avnotify.exe - knallt mehrmals die Woche den ganzen Bildschirm voll
                 ipmgui.exe   - lauert unten rechts im Tray und vergreift sich
                                mehrmals tglich am Desktop-Eigentum der Nutzer.

                 Diese dreisten bergriffe stellt man am besten dadurch ab, 
                 dass man zu einem anderen Anbieter wechselt, beispielsweise zu Avast.

                 Oder man blockiert die Avira-Monster-Werbung mit den folgenden AutoIt-Skripten
                 Script1 = AntiWerbung.exe = Ein/Aus-Schalter fr Script 2 und 3
                 Script2 = Kill-ipmGui.exe  = schliet 'ipmgui.exe' automatisch
                 Script3 = Kill-avNotify.exe= schliet 'avnotify.exe' automatisch

VersionInfo:     Version 1,9b-beta unterscheidet sich von Version 1,9-beta nur darin,
                 dass die Arbeitslogik von Script2 und Script3 jetzt auf den Befehlen
                 'ProcessExists($MonsterEXE)' und 'Sleep(400)'
                 und nicht mehr auf dem dem Befehl  'ProcessWait($MonsterEXE)' aufbaut.

                 Die 400 Millisekunden Pause sorgt dafr, dass die Prozessorbelastung
                 von ber 6% auf unter 0,5% zurckgeht, indem der Prozessor nicht mehr
                 unntig mit Leerlauf belastet wird.

                 Version 1,9b-beta zeigt seinen Zustand zudem durch die Icon-Farbe an.
                 Rot/Wei = Werbung gesperrt; Rot/Gelb = Werbung erlaubt.
                 

#ce ----------------------------------------------------------------------------

; Script Start 

#include <Constants.au3>
#NoTrayIcon

dim $ipmName = "Kill-ipmGui.exe"
dim $avnName = "Kill-avNotify.exe"

dim $myTitel = "AntiWerBung - "

dim $AngriffsCounter01 = 'imp-Angriffe.dat'
dim $AngriffsCounter02 = 'avn-Angriffe.dat'

dim $ipmAngriffeOld = 0
dim $ipmAngriffeNeu = 0
dim $avnAngriffeOld = 0
dim $avnAngriffeNeu = 0


Opt("TrayOnEventMode", 1)
Opt("TrayMenuMode", 1) ; Default tray menu items (Script Paused/Exit) will not be shown.


Local $aboutitem = TrayCreateItem("A n t i W e r B u n g  -  v 1.9b")
TrayItemSetOnEvent(-1, "funcAbout")

TrayCreateItem("")

; Radio menuitem Group
Local $radio = TrayCreateItem("Avira Werbung ist verboten", -1, -1, 1)
TrayItemSetOnEvent(-1, "funcWerbungVerbieten")
TrayItemSetState(-1, $TRAY_CHECKED)

TrayCreateItem("Avira Werbung ist erwnscht", -1, -1, 1)
TrayItemSetOnEvent(-1, "funcWerbungErlauben")

TrayCreateItem(""); 
Local $resetitem = TrayCreateItem("Avira Werbung Zurcksetzen")
TrayItemSetOnEvent(-1, "funcResetCounters")
Local $statitem = TrayCreateItem("Statistik noch in Arbeit")
TrayItemSetOnEvent(-1, "funcStatistik")

TrayCreateItem(""); 
Local $helpitem = TrayCreateItem("Hilfe")
TrayItemSetOnEvent(-1, "funcHelp")

TrayCreateItem("")
Local $exititem = TrayCreateItem("Exit")
TrayItemSetOnEvent(-1, "funcExit")

TraySetState()
TraySetToolTip(" A n t i  W e r  B u n g" & @LF &  "sperrt Avira Werbung")
funcReadDatum()
funcStartKillers()
funcReadAngriffsZahl()
$ipmAngriffeOld = $ipmAngriffeNeu 
$avnAngriffeOld = $avnAngriffeNeu 
funcZeigeAngriffsZahl()

While 1
      Sleep(30000); 
      funcReadAngriffsZahl()
      If $ipmAngriffeOld <> $ipmAngriffeNeu Then
            $ipmAngriffeOld = $ipmAngriffeNeu 
            funcZeigeAngriffsZahl()
      EndIf
      If $avnAngriffeOld <> $avnAngriffeNeu Then
            $avnAngriffeOld = $avnAngriffeNeu 
            funcZeigeAngriffsZahl()
      EndIf
WEnd

Exit

; Functions

Func funcReadAngriffsZahl()
            $ipmAngriffeNeu = 0
            Local $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter01,0)
            If $AnzahlFile <> -1 Then
                $ipmAngriffeNeu = FileReadLine($AnzahlFile)
            EndIf
            FileClose($AnzahlFile)
            $avnAngriffeNeu = 0
            Local $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter02,0)
            If $AnzahlFile <> -1 Then
                $avnAngriffeNeu = FileReadLine($AnzahlFile)
            EndIf
            FileClose($AnzahlFile)
EndFunc

Func funcResetCounters()
            TrayItemSetState($resetitem, $TRAY_UNCHECKED)
            Local $JaNein = MsgBox(4, $myTitel & "Reset", "Den Avira Angriffs-Zhler auf Null zurcksetzen?",4)
            IF $JaNein = 6 Then
                Local $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter01,2)
                FileWriteLine($AnzahlFile, "0")
                FileClose($AnzahlFile)
                $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter02,2)
                FileWriteLine($AnzahlFile, "0")
                FileClose($AnzahlFile)
                funcResetDatum()
            EndIf
            funcReadDatum()
            funcZeigeAngriffsZahl()
EndFunc

Func funcResetDatum()
            Local $StartDatum = @MDAY & "." & @MON & "." & @YEAR
            Local $DatumFile = FileOpen(".\Statistik\seitDatum.dat",2)
            FileWriteLine($DatumFile, $StartDatum)
            FileClose($DatumFile)
EndFunc


Func funcReadDatum()
            Local $StartDatum = "Avira Werbung Zurcksetzen"
            Local $DatumFile = FileOpen(".\Statistik\seitDatum.dat",0)
            If $DatumFile <> -1 Then
                $StartDatum = "Avira Werbung ab:  " & FileReadLine($DatumFile)
            EndIf
            FileClose($DatumFile)
            TrayItemSetText($resetitem, $StartDatum)
EndFunc

Func funcZeigeAngriffsZahl()
            Local $AngriffsZahl01 = 0
            Local $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter01,0)
            If $AnzahlFile <> -1 Then
                $AngriffsZahl01 = FileReadLine($AnzahlFile)
            EndIf
            FileClose($AnzahlFile)
            Local $AngriffsZahl02 = 0
            $AnzahlFile = FileOpen(".\Statistik\" & $AngriffsCounter02,0)
            If $AnzahlFile <> -1 Then
                $AngriffsZahl02 = FileReadLine($AnzahlFile)
            EndIf
            Local $Statistik = "abgewehrt:   " & $AngriffsZahl01 & "  +  " & $AngriffsZahl02 & "   PopUps"
            TrayItemSetText($statitem, $Statistik)
EndFunc

Func funcStatistik()
            TrayItemSetState($statitem, $TRAY_UNCHECKED)
            funcZeigeAngriffsZahl()
EndFunc

Func funcHelp()
            TrayItemSetState($helpitem, $TRAY_UNCHECKED)
            Run ("notepad.exe " & ".\Hilfe\AntiWerBung-Hilfe.txt")
EndFunc

Func funcAbout()
            TrayItemSetState($aboutitem, $TRAY_UNCHECKED)
            Local $MsgText = "-     A n t i W e r B u n g   (c) Mirxo 24.05.2012 Version 1.9b-beta   -"
            $MsgText = $MsgText & @LF & @LF & "- - - - -        Stoppt die Avira AntiVir Monster Werbung        - - - - -"
            $MsgText = $MsgText & @LF & @LF & "http://www.computerbase.de/forum/showthread.php?t=1058948"
            MsgBox(64, $myTitel & "About", $MsgText,10)
EndFunc

Func funcExit()
            funcStopKillers()
            Exit
EndFunc

Func funcWerbungVerbieten()
            ; Kill_ipmgui starten, sofern nicht bereits luft
            ; Kill_avnotify starten, sofern nicht bereits luft
            funcStartKillers()
EndFunc

Func funcWerbungErlauben()
            funcStopKillers()
EndFunc

Func funcStartKillers()
            Local $PID = ProcessExists($ipmName)
            If NOT $PID Then Run(".\WerbeStopp\" & $ipmName)           
            $PID = ProcessExists($avnName)
            If NOT $PID Then Run(".\WerbeStopp\" & $avnName)    
            TraySetIcon(".\Icon\white64x64.ico")
EndFunc

Func funcStopKillers()
            Local $PID = ProcessExists($ipmName)
            If $PID Then ProcessClose($PID)
            $PID = ProcessExists($avnName)
            If $PID Then ProcessClose($PID)
            TraySetIcon(".\Icon\yellow64x64.ico")
EndFunc


